cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
        - ${PROJECT_NAME}/bin
        - ${TEST_PROJECT_NAME}/bin

stages:
    - build
    - test
    - docker
    - deploy

dotnet-build:
    image: mcr.microsoft.com/dotnet/sdk:5.0
    before_script:
        - "dotnet restore ./${PROJECT_NAME}/${PROJECT_NAME}.sln"
    script:
        - "dotnet build ./${PROJECT_NAME}/${PROJECT_NAME}.sln"
    stage: build

build-push:
    image: docker:latest
    services:
        - docker:dind
    only:
        - master
    before_script:
        - "docker login -u ${DOCKER_USERNAME} -p ${DOCKER_PASSWORD}"
    script:
        - "docker build ./${PROJECT_NAME} -t ${DOCKER_ORG}/${DOCKER_CONTAINER_NAME}:latest -t ${DOCKER_ORG}/${DOCKER_CONTAINER_NAME}:${CI_COMMIT_SHA}"
        - "docker push ${DOCKER_ORG}/${DOCKER_CONTAINER_NAME} --all-tags"
    stage: docker

kubernetes-apply:
    image: henry40408/doctl-kubectl:latest
    only:
        refs:
            - branches
        changes:
            - kubernetes/*
    before_script:
        - doctl auth init -t ${DOCTL_ACCESS}
        - doctl kubernetes cluster kubeconfig save ${KUBECTL_CONNECT}
    script:
        - kubectl apply -f ./kubernetes
    stage: deploy

kubernetes-deploy:
    image: henry40408/doctl-kubectl:latest
    only:
        - master
    before_script:
        - doctl auth init -t ${DOCTL_ACCESS}
        - doctl kubernetes cluster kubeconfig save ${KUBECTL_CONNECT}
    script:
        - kubectl set image deployments/${DOCKER_CONTAINER_NAME} ${DOCKER_CONTAINER_NAME}=docker.io/power4all/${DOCKER_CONTAINER_NAME}:${CI_COMMIT_SHA} -n power4all
    stage: deploy
